package org.eclipse.jdt.internal.compiler.tool;

package .tmp;

import java.io.File;
import java.nio.charset.Charset;
import java.util.Locale;
import javax.tools.Diagnostic;
import javax.tools.JavaFileObject;
import org.eclipse.jdt.core.compiler.CategorizedProblem;
import org.eclipse.jdt.internal.compiler.problem.DefaultProblem;
import org.eclipse.jdt.internal.compiler.tool.EclipseCompilerImpl;
import org.eclipse.jdt.internal.compiler.tool.EclipseFileManager;
import org.eclipse.jdt.internal.compiler.tool.EclipseFileObject;

class null implements Diagnostic<JavaFileObject> {
  public String getCode() {
    return null;
  }
  
  public long getColumnNumber() {
    if (problem instanceof DefaultProblem)
      return ((DefaultProblem)problem).column; 
    return -1L;
  }
  
  public long getEndPosition() {
    if (problem instanceof DefaultProblem)
      return ((DefaultProblem)problem).getSourceEnd(); 
    return -1L;
  }
  
  public Diagnostic.Kind getKind() {
    if (problem.isError())
      return Diagnostic.Kind.ERROR; 
    if (problem.isWarning())
      return Diagnostic.Kind.WARNING; 
    if (problem instanceof DefaultProblem && ((DefaultProblem)problem).isInfo())
      return Diagnostic.Kind.NOTE; 
    return Diagnostic.Kind.OTHER;
  }
  
  public long getLineNumber() {
    if (problem instanceof DefaultProblem)
      return ((DefaultProblem)problem).getSourceLineNumber(); 
    return -1L;
  }
  
  public String getMessage(Locale locale) {
    return problem.getMessage();
  }
  
  public long getPosition() {
    if (problem instanceof DefaultProblem)
      return ((DefaultProblem)problem).getSourceStart(); 
    return -1L;
  }
  
  public JavaFileObject getSource() {
    if (problem instanceof DefaultProblem) {
      File f = new File(new String(((DefaultProblem)problem).getOriginatingFileName()));
      if (f.exists()) {
        Charset charset = (EclipseCompilerImpl.this.fileManager instanceof EclipseFileManager) ? 
          ((EclipseFileManager)EclipseCompilerImpl.this.fileManager).charset : Charset.defaultCharset();
        return (JavaFileObject)new EclipseFileObject(null, f.toURI(), JavaFileObject.Kind.SOURCE, charset);
      } 
      return null;
    } 
    return null;
  }
  
  public long getStartPosition() {
    return getPosition();
  }
}
